All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 # This program is licensed under the GNU GPL version 2 or later.
4 # (c) Richard "RichiH" Hartmann <richih.mailinglist@gmail.com>, 2011-2013
5 # For details, see LICENSE. To submit patches, you have to agree to
6 # license your code under the GNU GPL version 2 or later.
8 # While the following is not legally binding, the author would like to
9 # explain the choice of GPLv2+ over GPLv3+.
10 # The author prefers GPLv3+ over GPLv2+ but feels it's better to maintain
11 # full compatibility's with git. In case git ever changes its licensing terms,
12 # which is admittedly extremely unlikely to the point of being impossible,
13 # this software will most likely follow suit.
15 # This should always be the first line of code to facilitate debugging
16 [ -n "$VCSH_DEBUG" ] && set -vx
19 # Implemented in shell to avoid spawning another process
22 [ -z "$2" ] || file="${file%$2}"
30 echo "$SELF: fatal: $1" >&2
34 # We need to run getops as soon as possible so we catch -d and other
35 # options that will modify our behaviour.
36 # Commands are handled at the end of this script.
37 while getopts "c:dv" flag; do
38 if [ "$1" = '-d' ] || [ "$1" = '--debug' ]; then
42 elif [ "$1" = '-v' ];then
45 elif [ "$1" = '-c' ];then
46 VCSH_OPTION_CONFIG=$OPTARG
52 # Source file even if it's in $PWD and does not have any slashes in it
60 # Read configuration and set defaults if anything's not set
61 [ -n "$VCSH_DEBUG" ] && set -vx
62 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
64 # Read configuration files if there are any
65 [ -r "/etc/vcsh/config" ] && . "/etc/vcsh/config"
66 [ -r "$XDG_CONFIG_HOME/vcsh/config" ] && . "$XDG_CONFIG_HOME/vcsh/config"
67 if [ -n "$VCSH_OPTION_CONFIG" ]; then
68 # Source $VCSH_OPTION_CONFIG if it can be read and is in $PWD of $PATH
69 if [ -r "$VCSH_OPTION_CONFIG" ]; then
70 source_all "$VCSH_OPTION_CONFIG"
72 fatal "Can not read configuration file '$VCSH_OPTION_CONFIG'" 1
75 [ -n "$VCSH_DEBUG" ] && set -vx
78 [ -z "$VCSH_REPO_D" ] && VCSH_REPO_D="$XDG_CONFIG_HOME/vcsh/repo.d"
79 [ -z "$VCSH_HOOK_D" ] && VCSH_HOOK_D="$XDG_CONFIG_HOME/vcsh/hooks-enabled"
80 [ -z "$VCSH_BASE" ] && VCSH_BASE="$HOME"
81 [ -z "$VCSH_GITIGNORE" ] && VCSH_GITIGNORE='exact'
85 echo "usage: $SELF <options> <command>
90 -v Enable verbose mode
94 [<repo>] Clone from an existing repository
95 delete <repo> Delete an existing repository
96 enter <repo> Enter repository; spawn new instance of \$SHELL
97 help Display this help text
98 init <repo> Initialize a new repository
99 list List all repositories
100 list-tracked List all files tracked by vcsh
102 <repo> List files tracked by a repository
103 pull Pull from all vcsh remotes
104 push Push to vcsh remotes
106 <newname> Rename repository
108 <command> Use this repository
109 upgrade <repo> Upgrade repository to currently recommended settings
110 version Print version information
111 which <substring> Find substring in name of any tracked file
113 <repo> Write .gitignore.d/<repo> via git ls-files
115 <repo> <git command> Shortcut to run git commands directly
116 <repo> Shortcut to enter repository" >&2
120 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
124 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
128 echo "$SELF: error: $1" >&2
132 echo "$SELF: info: $1"
138 git remote add origin "$GIT_REMOTE"
139 git config branch.master.remote origin
140 git config branch.master.merge refs/heads/master
141 if [ $(git ls-remote origin master 2> /dev/null | wc -l ) -lt 1 ]; then
142 info "remote is empty, not merging anything"
146 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
148 error "'$object' exists." &&
151 [ "$VCSH_CONFLICT" = '1' ] &&
152 fatal "will stop after fetching and not try to merge!
153 Once this situation has been resolved, run 'vcsh run $VCSH_REPO_NAME git pull' to finish cloning.\n" 17
154 git merge origin/master
157 hook post-clone-retired
161 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
163 info "This operation WILL DESTROY DATA!"
164 files=$(git ls-files)
165 echo "These files will be deleted:
169 AGAIN, THIS WILL DELETE YOUR DATA!
170 To continue, type 'Yes, do as I say'"
172 [ "x$answer" = 'xYes, do as I say' ] || exit 16
173 for file in $files; do
174 rm -f $file || info "could not delete '$file', continuing with deletion"
176 rm -rf "$GIT_DIR" || error "could not delete '$GIT_DIR'"
187 [ -d "$GIT_DIR" ] || fatal "no repository found for '$VCSH_REPO_NAME'" 12
191 for hook in $VCSH_HOOK_D/$1* $VCSH_HOOK_D/$VCSH_REPO_NAME.$1*; do
192 [ -x "$hook" ] || continue
193 verbose "executing '$hook'"
199 [ ! -e "$GIT_DIR" ] || fatal "'$GIT_DIR' exists" 10
200 mkdir -p "$VCSH_BASE" || fatal "could not create '$VCSH_BASE'" 50
201 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
207 for repo in "$VCSH_REPO_D"/*.git; do
208 [ -d "$repo" ] && [ -r "$repo" ] && echo $(basename "$repo" .git)
213 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
218 for VCSH_REPO_NAME in $(list); do
225 git ls-files | sort -u
230 for VCSH_REPO_NAME in $(list); do
231 echo -n "$VCSH_REPO_NAME: "
232 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
241 for VCSH_REPO_NAME in $(list); do
242 echo -n "$VCSH_REPO_NAME: "
243 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
257 [ -d "$GIT_DIR_NEW" ] && fatal "'$GIT_DIR_NEW' exists" 54
258 mv -f "$GIT_DIR" "$GIT_DIR_NEW" || fatal "Could not mv '$GIT_DIR' '$GIT_DIR_NEW'" 52
260 # Now that the repository has been renamed, we need to fix up its configuration
261 # Overwrite old name..
262 GIT_DIR="$GIT_DIR_NEW"
263 $VCSH_REPO_NAME="$VCSH_REPO_NAME_NEW"
264 # ..and clobber all old configuration
277 # fake-bare repositories are not bare, actually. Set this to false
278 # because otherwise Git complains "fatal: core.bare and core.worktree
280 git config core.bare false
281 # in core.worktree, keep a relative reference to the base directory
282 git config core.worktree $(cd $GIT_DIR && GIT_WORK_TREE="$VCSH_BASE" git rev-parse --show-cdup)
283 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
284 git config vcsh.vcsh 'true'
286 [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ] && git add -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME"
292 export GIT_WORK_TREE="$(git rev-parse --show-toplevel)"
293 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
297 for VCSH_REPO_NAME in $(list); do
298 for VCSH_FILE in $(get_files); do
299 echo $VCSH_FILE | grep -q "$VCSH_COMMAND_PARAMETER" && echo "$VCSH_REPO_NAME: $VCSH_FILE"
305 # Don't do anything if the user does not want to write gitignore
306 if [ "x$VCSH_GITIGNORE" = 'xnone' ]; then
307 info "Not writing gitignore as '\$VCSH_GITIGNORE' is set to 'none'"
312 cd "$VCSH_BASE" || fatal "could not enter '$VCSH_BASE'" 11
313 gitignores=$(for file in $(git ls-files); do
315 echo $file; new="${file%/*}"
316 [ "$file" = "$new" ] && break
320 tempfile=$(mktemp) || fatal "could not create tempfile" 51
321 echo '*' > "$tempfile" || fatal "could not write to '$tempfile'" 57
322 for gitignore in $gitignores; do
323 echo "$gitignore" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57
324 if [ "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ -d "$gitignore" ]; then
325 { echo "$gitignore/*" | sed 's@^@!/@' >> "$tempfile" || fatal "could not write to '$tempfile'" 57; }
328 if diff -N "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" > /dev/null; then
329 rm -f "$tempfile" || error "could not delete '$tempfile'"
332 if [ -e "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ]; then
333 info "'$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' differs from new data, moving it to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'"
334 mv -f "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak" ||
335 fatal "could not move '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME.bak'" 53
337 mv -f "$tempfile" "$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME" ||
338 fatal "could not move '$tempfile' to '$VCSH_BASE/.gitignore.d/$VCSH_REPO_NAME'" 53
341 if [ ! "x$VCSH_GITIGNORE" = 'xexact' ] && [ ! "x$VCSH_GITIGNORE" = 'xrecursive' ] && [ ! "x$VCSH_GITIGNORE" = 'xnone' ]; then
342 fatal "'\$VCSH_GITIGNORE' must equal 'exact', 'recursive', or 'none'" 1
345 if [ "$1" = 'clone' ]; then
346 [ -z "$2" ] && fatal "$1: please specify a remote" 1
347 export VCSH_COMMAND="$1"
349 [ -n "$3" ] && VCSH_REPO_NAME="$3" || VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
350 export VCSH_REPO_NAME
351 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
352 elif [ "$1" = 'version' ]; then
353 echo "$SELF $VERSION"
355 elif [ "$1" = 'which' ]; then
356 [ -z "$2" ] && fatal "$1: please specify a filename" 1
357 [ -n "$3" ] && fatal "$1: too many parameters" 1
358 export VCSH_COMMAND="$1"
359 export VCSH_COMMAND_PARAMETER="$2"
360 elif [ "$1" = 'delete' ] ||
361 [ "$1" = 'enter' ] ||
363 [ "$1" = 'list-tracked-by' ] ||
364 [ "$1" = 'rename' ] ||
366 [ "$1" = 'upgrade' ] ||
367 [ "$1" = 'write-gitignore' ]; then
368 [ -z $2 ] && fatal "$1: please specify repository to work on" 1
369 [ "$1" = 'rename' -a -z "$3" ] && fatal "$1: please specify a target name" 1
370 [ "$1" = 'run' -a -z "$3" ] && fatal "$1: please specify a command" 1
371 export VCSH_COMMAND="$1"
372 export VCSH_REPO_NAME="$2"
373 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
374 [ "$VCSH_COMMAND" = 'rename' ] && { export VCSH_REPO_NAME_NEW="$3";
375 export GIT_DIR_NEW="$VCSH_REPO_D/$VCSH_REPO_NAME_NEW.git"; }
376 [ "$VCSH_COMMAND" = 'run' ] && shift 2
377 elif [ "$1" = 'list' ] ||
378 [ "$1" = 'list-tracked' ] ||
380 [ "$1" = 'push' ]; then
381 export VCSH_COMMAND="$1"
382 elif [ -n "$2" ]; then
383 export VCSH_COMMAND='run'
384 export VCSH_REPO_NAME="$1"
385 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
386 [ -d $GIT_DIR ] || { help; exit 1; }
389 elif [ -n "$1" ]; then
390 export VCSH_COMMAND='enter'
391 export VCSH_REPO_NAME="$1"
392 export GIT_DIR="$VCSH_REPO_D/$VCSH_REPO_NAME.git"
393 [ -d $GIT_DIR ] || { help; exit 1; }
395 # $1 is empty, or 'help'
399 # Did we receive a directory instead of a name?
400 # Mangle the input to fit normal operation.
401 if echo $VCSH_REPO_NAME | grep -q '/'; then
402 export GIT_DIR=$VCSH_REPO_NAME
403 export VCSH_REPO_NAME=$(basename "$VCSH_REPO_NAME" .git)
408 if [ ! -d "$check_directory" ]; then
409 if [ -e "$check_directory" ]; then
410 fatal "'$check_directory' exists but is not a directory" 13
412 info "attempting to create '$check_directory'"
413 mkdir -p "$check_directory" || fatal "could not create '$check_directory'" 50
418 check_dir "$VCSH_REPO_D"
419 [ ! "x$VCSH_GITIGNORE" = 'xnone' ] && check_dir "$VCSH_BASE/.gitignore.d"
421 verbose "$VCSH_COMMAND begin"
422 export VCSH_COMMAND=$(echo $VCSH_COMMAND | sed 's/-/_/g')
426 verbose "$VCSH_COMMAND end, exiting"